<template>
    <div>
        <div class="drawer drawer-end" style="z-index: 9">
            <input id="my-drawer-4" type="checkbox" class="drawer-toggle" />
            <div class="drawer-side">
                <label for="my-drawer-4" aria-label="close sidebar" class="drawer-overlay"></label>
                <ul class="menu p-4 w-80 min-h-full bg-base-200 text-base-content" >
                    <h4 class="font-bold text-2xl">{{ showcasedCon.name }}</h4>
                    <div class="rounded-md m-4 shadow-lg bannerBox">
                        <img src="https://gfx.dlastudenta.pl/photos/wiadomosci/Remcon_2024_logo.jpg"/>
                    </div>
                    <button class="btn btn-primary" @click="$router.push(`/konwent/${showcasedCon.id}`)">
                        Pokaż pełne informacje...
                    </button>
                    <div class="rounded-md m-4 shadow-lg infoBox">
                        <h4 class="text-left font-bold">Krótki opis:</h4>
                        <p class="text-left">{{ showcasedCon.description || "Niestety nie mamy opisu tego konwentu, jeśli byłeś możesz dodać!" }}</p>
                    </div>
                    <div class="rounded-md m-4 shadow-lg infoBox text-left">
                        <p v-if="showcasedCon.start_date">Początek: {{ parseDate(showcasedCon.start_date) }}</p>
                        <p>Lokalizacja: {{ showcasedCon.location ||  "Wypizdowie"}}</p>
                        <p>Organizator: nie wiem ale baza ludzie imo</p>
                    </div>
                </ul>
            </div>
        </div>
        <div class="container mx-auto py-5">
            <h1 class="text-3xl font-bold text-left">Kalendarz konwentów</h1>
            <hr/>
            <calendar-view
            :show-date="showDate"
            :items="conventionsList"
            locale="pl"
            class="theme-default"
            :startingDayOfWeek=1
            @click-item="showConPreview">
                <template #header="{ headerProps }">
                    <calendar-view-header
                    :header-props="headerProps"
                    @input="setShowDate" />
                </template>
            </calendar-view>
        </div>
        <button @click="throwError">Dziwny przycisk, ktory cos robi</button>
    </div>
</template>

<script>
import "vue-simple-calendar/dist/css/default.css"
import "vue-simple-calendar/dist/css/holidays-us.css"
import "../../node_modules/vue-simple-calendar/dist/style.css"
import { CalendarView, CalendarViewHeader } from "vue-simple-calendar"
import apiCalls from '@/services/apiCalls.service';
import utils from '@/services/utils.service';

export default {
    data() {
        return {
            showDate: new Date(),
            conventionsList: [],
            showcasedCon: {}
        }
    },
    mounted() {
        this.fetchConventions()
    },
    methods: {
        setShowDate(d) {
            this.showDate = d;
        },
        fetchConventions() {
            apiCalls.get('api/v1/conventions')
                .then(res => {
                    this.conventionsList = res
                    let namePairs = {
                        "name" : "title",
                        "start_date" : "startDate",
                        "end_date" : "endDate"
                    }
                    Object.keys(namePairs).forEach((nameKey) => {
                        this.conventionsList.forEach((con, index) => {
                            Object.defineProperty(this.conventionsList[index], namePairs[nameKey],
                               Object.getOwnPropertyDescriptor(this.conventionsList[index], nameKey));
                            delete this.conventionsList[index][nameKey]
                            if (nameKey == "name"){
                                let locationString
                                if (this.conventionsList[index]["location"]){
                                    locationString = ` - <b>${this.conventionsList[index]["location"]}</b>`
                                } else {
                                    locationString = " - <b>Wypizdowie</b>"
                                }
                                this.conventionsList[index]['title'] += locationString
                            }
                        })
                    })
                })

        },
        showConPreview(con){
            apiCalls.get(`api/v1/conventions/${con.id}`)
                .then(res => {
                    this.showcasedCon = res
                })
            let checkbox = document.getElementById('my-drawer-4')
            checkbox.checked = true
        },
        parseDate : utils.parseDate,
        throwError() {
            throw new Error('Sentry Error');
        }
    },
    components: {
        CalendarView,
        CalendarViewHeader
    }
}
</script>
<style scoped>
.cv-wrapper {
    min-height: 70vh;
}
</style>